Index: branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/AssemblyExtensions.cs
===================================================================
--- branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/AssemblyExtensions.cs	(revision 13338)
+++ branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/AssemblyExtensions.cs	(revision 13338)
@@ -0,0 +1,55 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Reflection;
+
+namespace HeuristicLab.PluginInfrastructure {
+  public static class AssemblyExtensions {
+    //Based on the code from http://stackoverflow.com/a/7156425
+    public static string GetCustomAttributeValue<T>(this Assembly assembly, string propertyName)
+       where T : Attribute {
+      if (assembly == null || string.IsNullOrEmpty(propertyName)) {
+        throw new ArgumentException("Arguments are not allowed to be null.");
+      }
+
+      object[] attributes = assembly.GetCustomAttributes(typeof(T), false);
+      if (attributes.Length == 0) {
+        throw new InvalidOperationException(string.Format("No attributes of type {0} found in assembly {1}", typeof(T).Name,
+          assembly.FullName));
+      }
+
+      var attribute = (T)attributes[0];
+      var propertyInfo = attribute.GetType().GetProperty(propertyName);
+      if (propertyInfo == null) {
+        throw new InvalidOperationException(string.Format("No property {0} found in attribute {1}, assembly: {2}",
+          propertyName, typeof(T).Name, assembly.FullName));
+      }
+
+      var value = propertyInfo.GetValue(attribute, null);
+      return value.ToString();
+    }
+
+    public static string GetFileVersion(this Assembly assembly) {
+      return GetCustomAttributeValue<AssemblyFileVersionAttribute>(assembly, "Version");
+    }
+  }
+}
Index: branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj
===================================================================
--- branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj	(revision 13335)
+++ branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/HeuristicLab.PluginInfrastructure-3.3.csproj	(revision 13338)
@@ -110,55 +110,7 @@
     <Reference Include="System" />
     <Reference Include="System.Core" />
-    <Reference Include="System.Data" />
-    <Reference Include="System.Deployment" />
-    <Reference Include="System.Drawing" />
-    <Reference Include="System.IdentityModel" />
-    <Reference Include="System.IO.Compression" />
-    <Reference Include="System.Runtime.Serialization" />
-    <Reference Include="System.ServiceModel" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Xml" />
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Advanced\InstallationManagerControl.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Advanced\InstallationManagerControl.Designer.cs">
-      <DependentUpon>InstallationManagerControl.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Advanced\InstallationManagerForm.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="Advanced\InstallationManagerForm.Designer.cs">
-      <DependentUpon>InstallationManagerForm.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Advanced\InstalledPluginsView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Advanced\InstalledPluginsView.Designer.cs">
-      <DependentUpon>InstalledPluginsView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Advanced\LicenseView.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="Advanced\LicenseView.Designer.cs">
-      <DependentUpon>LicenseView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Advanced\MultiSelectListView.cs">
-      <SubType>Component</SubType>
-    </Compile>
-    <Compile Include="Advanced\MultiSelectListView.Designer.cs">
-      <DependentUpon>MultiSelectListView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Advanced\PluginView.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="Advanced\PluginView.Designer.cs">
-      <DependentUpon>PluginView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Advanced\Util.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="AssemblyHelpers.cs" />
+    <Compile Include="AssemblyExtensions.cs" />
     <Compile Include="CommandLineArgumentHandling\Arguments\OpenArgument.cs" />
     <Compile Include="CommandLineArgumentHandling\Arguments\HideStarterArgument.cs" />
@@ -175,25 +127,6 @@
     <Compile Include="BaseClasses\ApplicationBase.cs" />
     <Compile Include="BaseClasses\PluginBase.cs" />
-    <Compile Include="Resources.Designer.cs">
-      <AutoGen>True</AutoGen>
-      <DesignTime>True</DesignTime>
-      <DependentUpon>Resources.resx</DependentUpon>
-    </Compile>
     <Compile Include="SandboxApplicationManager.cs" />
     <Compile Include="DefaultApplicationManager.cs" />
-    <Compile Include="ErrorHandling\ErrorDialog.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="ErrorHandling\ErrorDialog.Designer.cs">
-      <DependentUpon>ErrorDialog.cs</DependentUpon>
-    </Compile>
-    <Compile Include="ErrorHandling\ErrorHandling.cs">
-    </Compile>
-    <Compile Include="ErrorHandling\FrameworkVersionErrorDialog.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="ErrorHandling\FrameworkVersionErrorDialog.Designer.cs">
-      <DependentUpon>FrameworkVersionErrorDialog.cs</DependentUpon>
-    </Compile>
     <Compile Include="LightweightApplicationManager.cs" />
     <Compile Include="Interfaces\IPluginFile.cs" />
@@ -214,5 +147,4 @@
     <Compile Include="ApplicationManager.cs" />
     <Compile Include="PluginState.cs" />
-    <Compile Include="Main.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Sandboxing\SandboxManager.cs">
@@ -225,43 +157,4 @@
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
-    <Compile Include="Starter\AboutDialog.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="Starter\AboutDialog.Designer.cs">
-      <DependentUpon>AboutDialog.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Starter\SplashScreen.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="Starter\SplashScreen.Designer.cs">
-      <DependentUpon>SplashScreen.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Starter\StarterForm.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="Starter\StarterForm.Designer.cs">
-      <DependentUpon>StarterForm.cs</DependentUpon>
-    </Compile>
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Resources\Error.ico" />
-    <Content Include="Resources\HeuristicLab.ico" />
-    <None Include="Resources\HeuristicLabLogo.png" />
-    <None Include="Resources\HeuristicLabBanner.png" />
-    <None Include="Resources\VS2008ImageLibrary_Annotations_Error.png" />
-    <Content Include="Resources\VS2008ImageLibrary_Objects_Plugin.png" />
-    <EmbeddedResource Include="Resources.resx">
-      <Generator>ResXFileCodeGenerator</Generator>
-      <SubType>Designer</SubType>
-      <LastGenOutput>Resources.Designer.cs</LastGenOutput>
-    </EmbeddedResource>
-    <None Include="Resources\show_icons.png" />
-    <None Include="Resources\show_details.png" />
-    <None Include="Resources\VS2008ImageLibrary_Objects_File.png" />
-    <None Include="Resources\VS2008ImageLibrary_Objects_Document.png" />
-    <None Include="Resources\VS2008ImageLibrary_Objects_Assembly.png" />
-  </ItemGroup>
-  <ItemGroup>
-    <WCFMetadata Include="Service References\" />
   </ItemGroup>
   <ItemGroup>
Index: branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Manager/ApplicationDescription.cs
===================================================================
--- branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Manager/ApplicationDescription.cs	(revision 13335)
+++ branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Manager/ApplicationDescription.cs	(revision 13338)
@@ -42,7 +42,7 @@
     /// Gets or sets the version of the application.
     /// </summary>
-    internal Version Version {
+    public Version Version {
       get { return version; }
-      set { version = value; }
+      internal set { version = value; }
     }
     private string description;
@@ -60,7 +60,7 @@
     /// Gets or sets the boolean flag if the application should be automatically restarted.
     /// </summary>
-    internal bool AutoRestart {
+    public bool AutoRestart {
       get { return autoRestart; }
-      set { autoRestart = value; }
+      internal set { autoRestart = value; }
     }
 
@@ -69,7 +69,7 @@
     /// Gets or sets the name of the assembly that contains the IApplication type.
     /// </summary>
-    internal string DeclaringAssemblyName {
+    public string DeclaringAssemblyName {
       get { return declaringAssemblyName; }
-      set { declaringAssemblyName = value; }
+      internal set { declaringAssemblyName = value; }
     }
 
@@ -78,7 +78,7 @@
     /// Gets or sets the name of the type that implements the interface IApplication.
     /// </summary>
-    internal string DeclaringTypeName {
+    public string DeclaringTypeName {
       get { return declaringTypeName; }
-      set { declaringTypeName = value; }
+      internal set { declaringTypeName = value; }
     }
 
Index: branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Manager/PluginDescription.cs
===================================================================
--- branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Manager/PluginDescription.cs	(revision 13335)
+++ branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure/3.3/Manager/PluginDescription.cs	(revision 13338)
@@ -97,5 +97,5 @@
     /// Gets the error message why this plugin has been disabled.
     /// </summary>
-    internal string LoadingErrorInformation {
+    public string LoadingErrorInformation {
       get {
         return loadingErrorInformation;
